Public Class BgByDefinition

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtBg, "By Definition", "m3/m3")

		Input(pvtStdP, 0.101325, 0.101325, "MPa")
		Input(pvtStdT, 293, 293, "K")
		Input(pvtZFactorSC, 0, 0)
		Input(pvtP, 0.1, 68, "MPa")
		Input(pvtT, 0, 0, "K")
		Input(pvtZFactorRC, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
		   f.Val(pvtStdP), _
		   f.Val(pvtStdT), _
		   f.Val(pvtZFactorSC), _
		   f.Val(pvtP), _
		   f.Val(pvtT), _
		   f.Val(pvtZFactorRC))

	End Function

	Public Function DoEval( _
		ByVal stdP As Double, _
		ByVal stdT As Double, _
		ByVal ZfSC As Double, _
		ByVal P As Double, _
		ByVal T As Double, _
		ByVal ZfRC As Double) As Double

		DoEval = (ZfRC * T / P) / (ZfSC * stdT / stdP)

	End Function

End Class
