Public Class GasDensRCByByDefinition

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasDensRC, "By Definition", "g/m3")

		Input(pvtP, 0.1, 20, "MPa")
		Input(pvtT, 263, 293, "K")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtZFactorRC, 0, 1)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT), _
           f.Val(pvtGasMolMass), _
           f.Val(pvtZFactorRC))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal T As Double, _
	    ByVal Mg As Double, _
	    ByVal Zf As Double) As Double
	
	    Const R# = 8.31
	    DoEval = P * Mg / (Zf * R * T)
	    
	End Function

End Class
