Public Class GasHeatCapacityByShylov1985

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasHeatCapacity, "Shylov (1985)", "J/(kg*K)")

		Input(pvtP, 0.1, 20, "MPa")
		Input(pvtT, 263, 393, "K")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtGasPseudoPcr, 0, 0, "MPa")
		Input(pvtGasPseudoTcr, 0, 0, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtGasPseudoPcr), _
           f.Val(pvtT), _
           f.Val(pvtGasPseudoTcr), _
           f.Val(pvtGasMolMass))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal Ppcr As Double, _
	    ByVal T As Double, _
	    ByVal Tpcr As Double, _
	    ByVal Mg As Double) As Double
	    
	    Dim Ppr as Double = P / Ppcr
	    Dim Tpr as Double = T / Tpcr
	
	    DoEval = 4187.6 * (0.5374 + 0.00000117 * T ^ 2 - 0.007 * Mg + 1 / Mg * (-0.7491 + 4.599 * (Ppr / Tpr ^ 2) ^ 0.5 + 13.56 * Ppr * (Ppr / Tpr ^ 9) ^ 0.5))
	    
	End Function

End Class
