Public Class GasPseudoPcrByAbdElFattah1998

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasPseudoPcr, "Abd-El-Fattah (1998)", "Psia")

		Input(pvtGasSG, 0, 0)
		Input(pvtN2, 0, 0, "Frac")
		Input(pvtCO2, 0, 0, "Frac")
		Input(pvtH2S, 0, 0, "Frac")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtGasSG), _
           f.Val(pvtN2), _
           f.Val(pvtCO2), _
           f.Val(pvtH2S))

	End Function

	Public Function DoEval( _
	    ByVal gasSG as Double, _
	    ByVal N2 as Double, _
	    ByVal CO2 as Double, _
	    ByVal H2S as Double) as Double
	
	    Dim Pcr# = 703.194514 - 50.541243 * gasSG
	    Dim Tcr# = 173.7 + 308.0864 * gasSG
		Dim e# = 120 * ((CO2 + H2S) ^ 0.9 - (CO2 + H2S) ^ 1.6) + 15 * (H2S ^ 0.5 - H2S ^ 4)
	    
		Dim Tcr_t = Tcr - e
		DoEval = Pcr * Tcr_t / (Tcr + H2S * (1 - H2S) * e)
	
	End Function

End Class
