Public Class GasViscByDempsey1965

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasVisc, "Dempsey (1965)", "cPoise")

		Input(pvtP, 0, 0, "Psia")
		Input(pvtT, 0, 0, "R")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtGasPseudoPcr, 0, 0, "Psia")
		Input(pvtGasPseudoTcr, 0, 0, "R")
		Input(pvtGasViscOneAtm, 0, 0, "cPoise")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT), _
           f.Val(pvtGasMolMass), _
           f.Val(pvtGasPseudoPcr), _
           f.Val(pvtGasPseudoTcr), _
           f.Val(pvtGasViscOneAtm))

	End Function

	Public Function DoEval( _
	    ByVal P as Double, _
	    ByVal T as Double, _
	    ByVal Mg as Double, _
	    ByVal Ppcr as Double, _
	    ByVal Tpcr as Double, _
	    ByVal Ug_atm as Double) as Double
	
	    Dim Tpr# = T / Tpcr
	    Dim Ppr# = P / Ppcr
	
	    Dim a0# = -2.46211820
	    Dim a1# = 2.970547414
	    Dim a2# = -2.86264054*10^(-1)
	    Dim a3# = 8.05420522*10^(-3)
	    Dim a4# = 2.80860949
	    Dim a5# = -3.49803305
	    Dim a6# = 3.6037302*10^(-1)
	    Dim a7# = -1.04432413*10^(-2)
	    Dim a8# = -7.93385684*10^(-1)
	    Dim a9# = 1.39643306
	    Dim a10# = -1.49144925*10^(-1)
	    Dim a11# = 4.41015512*10^(-3)
	    Dim a12# = 8.39387178*10^(-2)
	    Dim a13# = -1.86408848*10^(-1)
	    Dim a14# = 2.03367881*10^(-2)
	    Dim a15# = -6.09579263*10^(-4)
	            
	    Dim ln# = a0 + a1 * ppr + a2 * ppr ^ 2 + a3 * ppr ^ 3 _
	        + Tpr * (a4 + a5 * ppr + a6 * ppr ^ 2 + a7 * ppr ^ 3) _
	        + Tpr ^ 2 * (a8 + a9 * ppr + a10 * ppr ^ 2 + a11 * ppr ^ 3) _
	        + Tpr ^ 3 * (a12 + a13 * ppr + a14 * ppr ^ 2 + a15 * ppr ^ 3)
	            
	    Dim Ug# = Ug_atm / Tpr * exp(ln)
	    Return Ug
	
	End Function

End Class
