Public Class GasViscByJossi

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasVisc, "Jossi", "mPa*s")

		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, 0, 0, "K")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtGasPseudoPcr, 0, 0, "MPa")
		Input(pvtGasPseudoTcr, 0, 0, "K")
		Input(pvtZFactorRC, 0, 0)
		Input(pvtGasViscOneAtm, 0, 0, "mPa*s")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT), _
           f.Val(pvtGasPseudoPcr), _
           f.Val(pvtGasPseudoTcr), _
           f.Val(pvtZFactorRC), _
           f.Val(pvtGasMolMass), _
           f.Val(pvtGasViscOneAtm))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal T As Double, _
	    ByVal Ppcr As Double, _
	    ByVal Tpcr As Double, _
	    ByVal Zf As Double, _
	    ByVal Mg As Double, _
	    ByVal Ug_atm As Double) As Double
	    
	    Dim Tpr as Double = T / Tpcr
	    Dim Ppr as Double = P / Ppcr
	
	    Dim rho_pr As Double = 0.27 * Ppr / Zf / Tpr
	    
	    Dim ksi As Double
	    ksi = Tpcr ^ (1 / 6) / (Mg ^ 0.5 * (Ppcr / 0.1013) ^ (2 / 3))
	    
	    Dim f As Double
	    f = 0.1023 + 0.023364 * rho_pr + 0.058533 * rho_pr ^ 2 - 0.0400758 * rho_pr ^ 3 + 0.0093324 * rho_pr ^ 4
	
	    DoEval = (f ^ 4 - 0.0001) / ksi + Ug_atm
	    
	End Function

End Class
