Public Class GasViscByLeeGonzalesIkin1975

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasVisc, "Lee, Gonzales, Ikin (1975)", "mPa*s")

		Input(pvtT, 559.8, 799.2, "R")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtGasViscOneAtm, 0, 0, "mPa*s")
		Input(pvtGasDensRC, 0, 0, "kg/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtGasDensRC), _
           f.Val(pvtGasMolMass), _
           f.Val(pvtT), _
           f.Val(pvtGasViscOneAtm))

	End Function

	Public Function DoEval( _
	    ByVal rhoG As Double, _
	    ByVal Mg As Double, _
	    ByVal T As Double, _
	    ByVal Ug_atm As Double) As Double
	
	    Dim hi# = 3.5 + 986 / T + 0.01 * Mg    
	    Dim f# = 2.4 - 0.2 * hi
	
	    DoEval = Ug_atm * Exp(hi * (rhoG * 0.001) ^ f)
	    
	End Function

End Class
