Public Class GasViscByLondonoArcherBlasingame2002

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasVisc, "Londono, Archer, Blasingame (2002)", "mPa*s")

		Input(pvtGasSG, 0, 0)
		Input(pvtT, -459.67, -459.67, "F")
		Input(pvtGasViscOneAtm, 0, 0, "mPa*s")
		Input(pvtGasDensRC, 0, 0, "g/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtGasSG), _
           f.Val(pvtGasDensRC), _
           f.Val(pvtT), _
           f.Val(pvtGasViscOneAtm))

	End Function

	Public Function DoEval( _
	    ByVal gasSG As Double, _
	    ByVal rhoG As Double, _
	    ByVal T As Double, _
	    ByVal Ug_atm As Double) As Double
	
	    Dim T2# = T ^ 2
	    Dim a# = 0.953363 - 1.07384 * T + 0.00131729 * T2
	    Dim b# = -0.971028 + 11.2077 * T + 0.09013 * T2
	    Dim c# = 1.01803 + 4.98986 * T + 0.302737 * T2
	    Dim d# = -0.990531 + 4.17585 * T - 0.63662 * T2
	    Dim e# = 1 - 3.19646 * T + 3.90961 * T2
	    Dim f# = -1.00364 - 0.181633 * T - 7.79089 * T2
	    Dim g# = 0.99808 - 1.62108 * T + 0.000634836 * T2
	    Dim h# = -1.00103 + 0.676875 * T + 4.62481 * T2
	
	    DoEval = Ug_atm + (a + b * rhoG + c * rhoG ^ 2 + d * rhoG ^ 3) / (e + f * rhoG + g * rhoG ^ 2 + h * rhoG ^ 3)
	    
	End Function

End Class
