Public Class GasViscByMcCain

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasVisc, "McCain", "mPa*s")

		Input(pvtT, 0, 0, "K")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtGasDensRC, 0, 0, "kg/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtGasDensRC), _
           f.Val(pvtGasMolMass), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal rhoG As Double, _
	    ByVal Mg As Double, _
	    ByVal T As Double) As Double
	
	    Dim a As Double
	    a = (22.64985 + 0.038808 * Mg) * T ^ 1.5 / (209.2 + 19.26 * Mg + 2.414953 * T)
	    
	    Dim b As Double
	    b = 3.448 + 548 / T + 0.01009 * Mg
	    
	    Dim c As Double
	    c = 2.447 - 0.2224 * b
	
	    DoEval = a * Exp(b * ((rhoG * 0.001) ^ c)) * 0.0001
	    
	End Function

End Class
