Public Class GasViscByShylov

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasVisc, "Shylov", "mPa*s")

		Input(pvtT, 473.4, 707.4, "R")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtGasDensRC, 0, 0, "kg/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtGasDensRC), _
           f.Val(pvtGasMolMass), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal rhoG As Double, _
	    ByVal Mg As Double, _
	    ByVal T As Double) As Double
	
	    Dim x# = 3.5 + 986 / T + 0.01 * Mg    
	    Dim K# = (9.41 + 0.02 * Mg) * T ^ 1.5 / (209 + 19 * Mg + T) * 0.0001    
	    Dim y# = 2.4 - 0.2 * x
	
	    DoEval = K * Exp(x * (rhoG * 0.001) ^ y)
	
	End Function

End Class
