Public Class GasViscOneAtmByDempsey1965

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasViscOneAtm, "Dempsey (1965)", "mPa*s")

		Input(pvtT, 0, 0, "K")
		Input(pvtGasMolMass, 0, 0, "g/mole")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtT), _
		   f.Val(pvtGasMolMass))

	End Function

	Public Function DoEval( _
	    ByVal T as Double, _
	    ByVal Mg as Double) as Double
	
	    Dim b0# = 1.11231913*10^(-2)
	    Dim b1# = 1.67726604*10^(-5)
	    Dim b2# = 2.11360496*10^(-9)
	    Dim b3# = -1.0948505*10^(-4)
	    Dim b4# = -6.4031639*10^(-8)
	    Dim b5# = -8.99374533*10^(-11)
	    Dim b6# = 4.57735189*10^(-7)
	    Dim b7# = 2.1290339*10^(-10)
	    Dim b8# = 3.97732249*10^(-13)        
	
	    Dim Ug_atm# = b0 + b1 * T + b2 * T ^ 2 + b3 * Mg + b4 * T * Mg _
	        + b5 * T ^ 2 * Mg + b6 * Mg ^ 2 + b7 * T * Mg ^ 2 + b8 * T ^ 2 * Mg ^ 2        
	     
	    return Ug_atm
	
	End Function
	

End Class
