Public Class GasViscOneAtmByLucas

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasViscOneAtm, "Lucas", "cPoise")

		Input(pvtT, 0, 0, "R")
		Input(pvtGasMolMass, 0, 0, "g/mole")
		Input(pvtGasPseudoPcr, 0, 0, "Psia")
		Input(pvtGasPseudoTcr, 0, 0, "R")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtGasMolMass), _
           f.Val(pvtT), _
           f.Val(pvtGasPseudoTcr), _
           f.Val(pvtGasPseudoPcr))

	End Function

	Public Function DoEval( _
	    ByVal Mg as Double, _
	    ByVal T as Double, _
	    ByVal Tpcr as Double, _
	    ByVal Ppcr as Double) as Double
	
	    Dim Tpr# = T / Tpcr
	
	    Dim ksi# = 9490 * (Tpcr / Mg ^ 3 / Ppcr ^ 4) ^ (1 / 6)
	    Dim Ug_atm# = (0.807 * Tpr ^ 0.618 - 0.357 * exp(- 0.449 * Tpr) + 0.340 * exp(- 4.058 * Tpr) + 0.018) / ksi
	    
	    Return Ug_atm
	
	End Function

End Class
