Public Class GasViscOneAtmByStanding

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtGasViscOneAtm, "Standing", "cPoise")

		Input(pvtGasSG, 0, 0)
		Input(pvtT, 0, 0, "R")
		Input(pvtN2, 0, 0, "Frac")
		Input(pvtCO2, 0, 0, "Frac")
		Input(pvtH2S, 0, 0, "Frac")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtGasSG), _
           f.Val(pvtT), _
           f.Val(pvtN2), _
           f.Val(pvtCO2), _
           f.Val(pvtH2S))

	End Function

	Public Function DoEval( _
	    ByVal gasSG as Double, _
	    ByVal T as Double, _
	    ByVal N2 as Double, _
	    ByVal CO2 as Double, _
	    ByVal H2S as Double) as Double
	
	    Dim logSG# = log10(gasSG)
		
		Dim Ug_atm# = (1.709 * 10 ^ (-5) - 2.062 * 10 ^ (-6) * gasSG) * (T - 460) _
			+ 8.188 * 10 ^ (-3) - 6.15 * 10 ^ (-3) * logSG
			
		Dim dUg_N2# = N2 * 10 ^ (-3) * (8.48 * logSG + 9.59)
		Dim dUg_CO2# = CO2 * 10 ^ (-3) * (9.08 * logSG + 6.24)
		Dim dUg_H2S# = H2S * 10 ^ (-3) * (8.49 * logSG + 3.73)
		
	    DoEval = Ug_atm + dUg_N2 + dUg_CO2 + dUg_H2S
	
	End Function
	
End Class
