Public Class ZFactorRCByShylov1985

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtZFactorRC, "Shylov (1985)", "")

		Input(pvtP, 0.1, 20, "MPa")
		Input(pvtT, 263, 293, "K")
		Input(pvtGasPseudoPcr, 0, 0, "MPa")
		Input(pvtGasPseudoTcr, 0, 0, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtGasPseudoPcr), _
           f.Val(pvtT), _
           f.Val(pvtGasPseudoTcr))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal Ppcr As Double, _
	    ByVal T As Double, _        
	    ByVal Tpcr As Double) As Double
	
	    Dim Ppr as Double = P / Ppcr
	    Dim Tpr as Double = T / Tpcr
	 
	    DoEval = 1 - 3.52 * Ppr / 10 ^ (0.9813 * Tpr) + 0.274 * Ppr ^ 2 / 10 ^ (0.8157 * Tpr)
	    
	End Function

End Class
