Public Class ZFactorRCByBertlo

	Inherits GasCorrelation

	Public Sub New()
		MyBase.New(pvtZFactorRC, "Bertlo", "")

		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, 0, 0, "K")
		Input(pvtGasPseudoPcr, 0, 0, "MPa")
		Input(pvtGasPseudoTcr, 0, 0, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT), _
           f.Val(pvtGasPseudoPcr), _
           f.Val(pvtGasPseudoTcr))

	End Function

	Public Function DoEval( _
	    ByVal P as Double, _
	    ByVal T as Double, _
	    ByVal Pcr as Double, _
	    ByVal Tcr as Double) as Double
	
	    Dim Ppr# = P / Pcr
	    Dim Tpr# = T / Tcr
	    return 1 - 0.4273 * Ppr * Tpr ^ (-3.668)
	    
	End Function

End Class
