Public Class BoByAlMarhoun1988

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtBo, "Al Marhoun (1988)", "m3/m3")

		Input(pvtOilSG, 0.804, 0.938)
		Input(pvtGasSG, 0.752, 1.367)
		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, 296, 389, "K")
		Input(pvtPbub, 0, 0, "MPa")
		Input(pvtRs, 4.7, 288.5, "std m3/m3")
		Input(pvtOilCo, 0, 0, "MPa-1")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRs), _
           f.Val(pvtT), _
           f.Val(pvtP), _
           f.Val(pvtPbub), _
           f.Val(pvtOilCo))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rs As Double, _
	    ByVal T As Double, _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal oilCo As Double) As Double
	
	    Dim f As Double
	    f = Rs ^ 0.74239 * gasSG ^ 0.323294 * oilSG ^ (-1.20204)
	
	    Dim Bob As Double = 0.497069 + 0.001553333 * T + 0.0065186 * f + 0.00004054133 * f ^ 2
	
	    If P < Pb Then
	        DoEval = Bob
	    Else
	        DoEval = Bob * Exp(oilCo * (Pb - P))
	    End If
	
	End Function

End Class
