Public Class BoByGlaso1994

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtBo, "Glaso (1994)", "m3/m3")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtT, -459.67, -459.67, "F")
		Input(pvtRs, 0, 0, "std scf/bbl")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtRs), _
           f.Val(pvtT), _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG))

	End Function

	Public Function DoEval( _
	    ByVal Rs as Double, _
	    ByVal T as Double, _
	    ByVal oilSG as Double, _
	    ByVal gasSG as Double) as Double
	        
	    Dim Bob# = Rs * (gasSG / oilSG) ^ 0.526 + 0.968 * T
	    Dim A# = - 6.58511 + 2.91329 * log10(Bob) - 0.27683 * log10(Bob) ^ 2            
	    return 1 + 10 ^ A
	    
	End Function

End Class
