Public Class BoByMcCain1947

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtBo, "McCain (1947)", "m3/m3")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, -459.67, 325.13, "F")
		Input(pvtPbub, 0, 0, "MPa")
		Input(pvtRs, 0, 0, "std m3/m3")
		Input(pvtOilCo, 0, 0, "MPa-1")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRs), _
           f.Val(pvtT), _
           f.Val(pvtP), _
           f.Val(pvtPbub), _
           f.Val(pvtOilCo))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rs As Double, _
	    ByVal T As Double, _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal oilCo As Double) As Double
	
	    Dim mult As Double
	    mult = 5.551931 * Rs * (gasSG / oilSG) ^ 0.5 + 1.25 * T
	
	    Dim Bob As Double = 0.9759 + 0.00012 * mult ^ 1.2
	
	    If P < Pb Then
	        DoEval = Bob
	    Else
	        DoEval = Bob * Exp(oilCo * (Pb - P))
	    End If
	
	End Function

End Class
