Public Class BoByMoiseeva1972

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtBo, "Moiseeva (1972)", "m3/m3")

		Input(pvtRsb, 0, 0, "std m3/m3")
		Input(pvtOilSG, 0, 0)
		Input(pvtP, 0, 0, "Bar")
		Input(pvtPbub, 0, 0, "Bar")
		Input(pvtRs, 0, 0, "std m3/m3")
		Input(pvtOilCo, 0, 0, "MPa-1")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtRs), _
           f.Val(pvtRsb), _
           f.Val(pvtP), _
           f.Val(pvtPbub), _
           f.Val(pvtOilCo))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal Rs As Double, _
	    ByVal Rsb As Double, _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal Co As Double) As Double
	
	    Co *= CoMPa2bar
	
	    Dim Bo As Double
	
	    If ((oilSG > 0.92) And (oilSG < 0.93)) Or (Rsb > 40) Then
	        Bo = 1 + 0.002056 * Rs
	    Else
	        Bo = 1 + 0.002056 * Rs + (0.0235 + 0.0007 * Rs - 0.02518 * Exp(-0.0758 * Rs)) * (0.93 - oilSG) / 0.12
	    End If
	
	    If P <= Pb Then
	        DoEval = Bo
	    Else
	        DoEval = Bo * Exp(Co * (Pb - P))
	    End If
	
	End Function

End Class
