Public Class BoByPetroskyAndFarshad1993

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtBo, "Petrosky and Farshad (1993)", "m3/m3")

		Input(pvtOilSG, 0.802, 0.957)
		Input(pvtGasSG, 0.5781, 0.8519)
		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, 114.53, 287.33, "F")
		Input(pvtPbub, 0, 0, "MPa")
		Input(pvtRs, 39, 253, "std m3/m3")
		Input(pvtOilCo, 0, 0, "MPa-1")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRs), _
           f.Val(pvtT), _
           f.Val(pvtP), _
           f.Val(pvtPbub), _
           f.Val(pvtOilCo))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rs As Double, _
	    ByVal T As Double, _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal oilCo As Double) As Double
	
	    Dim mult As Double
	    mult = 1.898 * Rs ^ 0.3738 * (gasSG ^ 0.2914 / oilSG ^ 0.6265) + 0.24626 * T ^ 0.5371
	
	    Dim Bob As Double = 1.0113 + 0.000072046 * mult ^ 3.0936
	
	    If P < Pb Then
	        DoEval = Bob
	    Else
	        DoEval = Bob * Exp(oilCo * (Pb - P))
	    End If
	
	End Function

End Class
