Public Class BoByShylov1985

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtBo, "Shylov (1985)", "m3/m3")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtP, 0.1, 35, "MPa")
		Input(pvtT, 273, 408, "K")
		Input(pvtRs, 0, 80, "std m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtRs), _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal Rs As Double, _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    Dim rhoOsc# = 1000 * oilSG
	    Dim rhoGsc# = 1.205 * gasSG
	
	    DoEval = Exp(0.0516 + 0.00241 * Rs - _
	        0.000862 * P + 0.000474 * T - 0.000267 * rhoOsc + 0.0557 * rhoGsc)
	
	End Function

End Class
