Public Class BoByTagintseva1983LightOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtBo, "Tagintseva (1983, light oils)", "m3/m3")

		Input(pvtRsb, 0, 0, "std m3/m3")
		Input(pvtOilSG, 0, 0)
		Input(pvtP, 0, 0, "Bar")
		Input(pvtPbub, 0, 0, "Bar")
		Input(pvtRs, 0, 0, "std m3/m3")
		Input(pvtOilCo, 0, 0, "MPa-1")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtRs), _
           f.Val(pvtRsb), _
           f.Val(pvtP), _
           f.Val(pvtPbub), _
           f.Val(pvtOilCo))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal Rs As Double, _
	    ByVal Rsb As Double, _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal Co As Double) As Double
	
	    Co *= CoMPa2bar
	
	    Dim Bo As Double
	    If Rsb > 40 Then
	        Bo = 2.136 - 1.189 * oilSG + 0.0014 * Rs
	    Else
	        Bo = 1 / (0.861 + 0.114 * oilSG) + 0.0048 * (Rs ^ 0.624) / (oilSG ^ 6.655)
	    End If
	
	    If P <= Pb Then
	        DoEval = Bo
	    Else
	        DoEval = Bo * Exp(Co * (Pb - P))
	    End If
	
	End Function

End Class
