Public Class DeadViscByDindorukChristman2001

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "Dindoruk-Christman (2001)", "cPoise")

		Input(pvtRsb, 0, 0, "std scf/bbl")
		Input(pvtOilSG, 0, 0)
		Input(pvtT, -459.67, -459.67, "F")
		Input(pvtPbub, 0, 0, "Psia")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtT), _
           f.Val(pvtOilSG), _
           f.Val(pvtRsb), _
           f.Val(pvtPbub))

	End Function

	Public Function DoEval( _
	    ByVal T as Double, _
	    ByVal oilSG as Double, _
	    ByVal Rsb as Double, _
	    ByVal Pb as Double) as Double
	
	    oilSG = API(oilSG)
	    
	    Dim a1# = 14.505357625
	    Dim a2# = -44.868655416
	    Dim a3# = 9.36579*10^9
	    Dim a4# = -4.194017808
	    Dim a5# = -3.1461171*10^(-9)
	    Dim a6# = 1.517652716
	    Dim a7# = 0.010433654
	    Dim a8# = -0.00077688
	    
	    Dim A# = a1 * log10(T) + a2
	    Return a3 * T ^ a4 * log10(oilSG) ^ A / (a5 * Pb ^ a6 + a7 * Rsb ^ a8)
	
	End Function

End Class
