Public Class DeadViscByEgbogahAndJack1994HeavyOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "Egbogah and Jack (1994, heavy oils)", "mPa*s")

		Input(pvtOilSG, 0.92, 1)
		Input(pvtT, 58.73, 175.73, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim loglogDeadViscosity# = 2.06492 - 0.0179 * oilSG - 0.70226 * Log10(T)
	    
	    return 10 ^ (10 ^ loglogDeadViscosity) - 1
	
	End Function

End Class
