Public Class DeadViscByEgbogahAndJack1994LightOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "Egbogah and Jack (1994, light oils)", "mPa*s")

		Input(pvtOilSG, 0, 0.87)
		Input(pvtT, 58.73, 175.73, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim loglogDeadViscosity# = 1.67083 - 0.017628 * oilSG - 0.61304 * Log10(T)
	
	    return 10 ^ (10 ^ loglogDeadViscosity) - 1
	
	End Function

End Class
