Public Class DeadViscByMcCain1991

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "McCain (1991)", "mPa*s")

		Input(pvtOilSG, 0.746, 1.037)
		Input(pvtT, 58.73, 175.73, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim loglogDeadViscosity# = 1.8653 - 0.025086 * oilSG - 0.5644 * Log10(T)
	
	    return 10 ^ (10 ^ loglogDeadViscosity) - 1
	
	End Function

End Class
