Public Class DeadViscByMoiseeva1972283T303

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "Moiseeva (1972, 283<T<303)", "mPa*s")

		Input(pvtOilSG, 0, 0)
		Input(pvtT, 9.85, 29.85, "C")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    Dim mu20C As Double
	    Dim alpha As Double
	    Dim k As Double
	    Dim b As Double
	
	    mu20C = 10 ^ (-0.844 - 0.098 / Log10(oilSG)) - 1585000 * oilSG ^ 133
	
	    Select Case mu20C
	        Case 23.93 To 47.14
	            k = 0.05230504093
	            b = -0.2516596295
	        Case 47.14 To 78.57
	            k = 0.05342029908
	            b = -0.3042328985
	        Case 78.57 To 85
	            k = 0.0833592535
	            b = -2.656536547
	        Case Else
	            If mu20C < 23.93 Then
	                k = 0.04327857269
	                b = -0.03565624448
	            End If
	            If mu20C > 85 Then
	                k = 0.08331388565
	                b = -2.65268028
	            End If
	    End Select
	
	    alpha = k * mu20C + b
	    DoEval = mu20C - alpha * (T - 20)
	
	End Function

End Class
