Public Class DeadViscByMoiseeva1972303T323

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "Moiseeva (1972, 303<T<323)", "mPa*s")

		Input(pvtOilSG, 0, 0)
		Input(pvtT, 29.85, 49.85, "C")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    Dim mu20C As Double
	    Dim alpha As Double
	    Dim k As Double
	    Dim b As Double
	
	    mu20C = 10 ^ (-0.844 - 0.098 / Log10(oilSG)) - 1585000 * oilSG ^ 133
	
	    Select Case mu20C
	        Case 55 To 62.86
	            k = 0.0272264631
	            b = 0.2885445293
	        Case 62.86 To 85
	            k = 0.04837398374
	            b = -1.040788618
	        Case 85 To 102.86
	            k = 0.06002239642
	            b = -2.030903695
	        Case Else
	            If mu20C < 55 Then
	                k = 0.03296559706
	                b = -0.0271078382
	            End If
	            If mu20C > 102.86 Then
	                k = 0.06668611435
	                b = -2.716333722
	            End If
	    End Select
	
	    alpha = k * mu20C + b
	    DoEval = mu20C - alpha * (T - 20)
	    
	End Function

End Class
