Public Class DeadViscByMoiseeva1972323T343

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "Moiseeva (1972, 323<T<343)", "mPa*s")

		Input(pvtOilSG, 0, 0)
		Input(pvtT, 49.85, 69.85, "C")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    Dim mu20C As Double
	    Dim alpha As Double
	    Dim k As Double
	    Dim b As Double
	
	    mu20C = 10 ^ (-0.844 - 0.098 / Log10(oilSG)) - 1585000 * oilSG ^ 133
	
	    Select Case mu20C
	        Case 56.79 To 84.29
	            k = 0.02985454545
	            b = -0.4454396364
	        Case 84.29 To 105.71
	            b = -1.305322129
	            k = 0.04005602241
	        Case Else
	            If mu20C < 56.79 Then
	                k = 0.02243190838
	                b = -0.02390807676
	            End If
	            If mu20C > 105.71 Then
	                k = 0.04744576627
	                b = -2.086491952
	            End If
	    End Select
	
	    alpha = k * mu20C + b
	    DoEval = mu20C - alpha * (T - 20)
	
	End Function

End Class
