Public Class DeadViscByBealStanding1947

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtDeadVisc, "Beal-Standing (1947)", "mPa*s")

		Input(pvtOilSG, 0.7245, 0.9561)
		Input(pvtT, 311, 399, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim a# = 10 ^ (0.43 + 8.33 / oilSG)
	
	    DoEval = (0.32 + 1.8 * 10 ^ 7 / oilSG ^ 4.53) * (360 / (1.8 * T - 260)) ^ a
	
	End Function

End Class
