Public Class OilCoByLabedi1994AtPPb

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilCo, "Labedi (1994, at P > Pb)", "MPa-1")

		Input(pvtOilSG, 0, 0.87)
		Input(pvtP, 0, 36, "MPa")
		Input(pvtT, 127.13, 305.33, "F")
		Input(pvtPbub, 3.59, 43.84, "MPa")
		Input(pvtBo, 1.88, 2.92, "m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtPbub), _
           f.Val(pvtBo), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal Pb As Double, _
	    ByVal Bo As Double, _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    DoEval = 145.0377 * ((10 ^ (-6.1646) * Bo ^ 1.8789 * oilSG ^ 0.3646 * T ^ 0.1966) _
	        - (1 - Pb / P) * (10 ^ (-8.98) * Bo ^ 3.9392 * T ^ 1.349))
	
	End Function

End Class
