Public Class OilCoByMcCain1991AtPPb

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilCo, "McCain (1991, at P > Pb)", "MPa-1")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtP, 0, 36, "MPa")
		Input(pvtT, -459.67, 328.73, "F")
		Input(pvtRs, 0, 0, "std m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRs), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rs As Double, _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    'If P < Pb Then
		'P = P / 0.006895
	    'DoEval = 0.000107741 * P ^ (-1.497) * T ^ 1.115 * oilSG ^ 0.533 * (Rs / 0.1801) ^ 0.184
	    'Else
	    DoEval = (-1433 + 27.759655 * Rs + 17.2 * T - 1180 * gasSG + 12.61 * oilSG) / (P * 100000)
	    'End If
	
	End Function

End Class
