Public Class OilCoByPetroskyAndFarshad1993AtPPb

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilCo, "Petrosky and Farshad (1993, at P > Pb)", "MPa-1")

		Input(pvtOilSG, 0.802, 0.957)
		Input(pvtGasSG, 0.5781, 0.8519)
		Input(pvtP, 1696.8817984046, 10688.9050036258, "Psia")
		Input(pvtT, 114.53, 305.33, "F")
		Input(pvtRs, 39, 253, "std m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRs), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rs As Double, _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    DoEval = (0.0000001705) / 0.006895 * (Rs / 0.1801) ^ 0.69357 * gasSG ^ 0.1885 * oilSG ^ 0.3272 * T ^ 0.6729 * P ^ (-0.5906)
	
	End Function

End Class
