Public Class OilCoByTagintseva1985LightOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilCo, "Tagintseva (1985, light oils)", "MPa-1")

		Input(pvtP, 117, 737, "Bar")
		Input(pvtRs, 39, 253, "std m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtRs), _
           f.Val(pvtP))

	End Function

	Public Function DoEval( _
	    ByVal Rs As Double, _
	    ByVal P As Double) As Double
	
	    DoEval = P * (0.3953 * Log(Rs) ^ 2 - 1.4709 * Rs + 1.4659)
	
	    DoEval /= CoMPa2bar
	
	End Function

End Class
