Public Class OilDensRCByMoiseeva1972

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilDensRC, "Moiseeva (1972)", "kg/m3")

		Input(pvtOilSG, 0, 0)
		Input(pvtP, 0, 0, "MPa")
		Input(pvtPbub, 0, 0, "MPa")
		Input(pvtRs, 0, 0, "std m3/m3")
		Input(pvtOilCo, 0, 0, "MPa-1")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtRs), _
           f.Val(pvtP), _
           f.Val(pvtPbub), _
           f.Val(pvtOilCo))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal Rs As Double, _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal Co As Double) As Double
	
	    Dim D As Double
	    If oilSG > 0.87 Then
	        D = (988 - Rs) * oilSG
	    Else
	        'DoEval = (1.35 * oilSG - 0.0087 * Rs - 0.312) * 1000
	        D = 1350 * oilSG - 0.92 * Rs - 312
	    End If
	
	    If P <= Pb Then
	        DoEval = D
	    Else
	        DoEval = D * Exp(Co * (P - Pb))
	    End If
	
	End Function

End Class
