Public Class OilDensRCByTagintsevaLightOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilDensRC, "Tagintseva (light oils)", "kg/m3")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtRs, 0, 0, "std m3/m3")
		Input(pvtBo, 0, 0, "m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtBo), _
           f.Val(pvtRs))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Bo As Double, _
	    ByVal Rs As Double) As Double
	
	    DoEval = (1000 * oilSG + 1.205 * gasSG * Rs) / Bo
	
	End Function

End Class
