Public Class OilGasTensByRN

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilGasTens, "RN", "N/m")

		Input(pvtOilSG, 0, 0)
		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, 0, 0, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    Dim C# = 1 - 0.235 * P ^ 0.45
	    Dim sigmaT As Double
	
	    If T > 311 Then
	        sigmaT = 0.07131 - 0.03638 / oilSG
	    Else
	        sigmaT = (0.074581 - 0.03638 / oilSG - 0.000026 * T)
	    End If
	
	    DoEval = C * sigmaT
	
	End Function

End Class
