Public Class OilGasTensByRamey1973

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilGasTens, "Ramey (1973)", "N/m")

		Input(pvtGasDensRC, 0, 0, "kg/m3")
		Input(pvtOilDensRC, 0, 0, "kg/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilDensRC), _
           f.Val(pvtGasDensRC))

	End Function

	Public Function DoEval( _
	    ByVal rhoO As Double, _
	    ByVal rhoG As Double) As Double
	
	    DoEval = 0.03 + 0.000036 * (rhoO - rhoG)
	
	End Function

End Class
