Public Class OilGasTensByShylov1985

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilGasTens, "Shylov (1985)", "N/m")

		Input(pvtOilSG, 0, 0)
		Input(pvtP, 0, 0, "kg/sm2")
		Input(pvtT, -273.15, -273.15, "C")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG as Double, _
	    ByVal P as Double, _
	    ByVal T as Double) as Double
	
	    Dim sigmaSC# = 10 ^ (-3) * (53.2 * oilSG - 15.5)
	    
	    Dim KT# = 1.056 - 0.0028 * T
	    Dim Kp# = 0.0000199 * P ^ 2 - 0.0081 * P + 0.9668
	
	    return sigmaSC * KT * Kp
	
	End Function

End Class
