Public Class OilHeatCapacityByGimatudinov1983

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilHeatCapacity, "Gimatudinov (1983)", "J/(kg*K)")

		Input(pvtOilSG, 0, 0)
		Input(pvtT, 0, 0, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal T As Double) As Double
	
	    DoEval = 1000 * 1.5072 * (1 + 0.01 * (T - 223.1) * (1.14 - oilSG))
	    
	End Function

End Class
