Public Class OilWaterTensByGimatudinov1983

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtOilWaterTens, "Gimatudinov (1983)", "N/m")

		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, 0, 0, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    Dim IFT_OilGas# = 10 ^ (-(1.58 - 0.05 * P)) - 0.000072 * (T - 305)
	    Dim IFT_WaterGas# = 10 ^ ((-1) * (1.19 + 0.01 * P))
	
	    DoEval = IFT_WaterGas - IFT_OilGas
	
	End Function

End Class
