Public Class PbubByAlMarhoun1988

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "Al Marhoun (1988)", "MPa")

		Input(pvtRsb, 4.7, 288, "std m3/m3")
		Input(pvtOilSG, 0.804, 0.938)
		Input(pvtGasSG, 0.752, 1.367)
		Input(pvtT, 296, 389, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRsb), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rsb As Double, _
	    ByVal T As Double) As Double
	
	    DoEval = 0.006895 * (0.00538088 * (Rsb / 0.1801) ^ 0.715082 * gasSG ^ (-1.87784) * oilSG ^ 3.1437 * (1.8 * T) ^ 1.32657)
	
	End Function

End Class
