Public Class PbubByDindorukChristman2001

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "Dindoruk-Christman (2001)", "Psia")

		Input(pvtRsb, 0, 0, "std scf/bbl")
		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtT, -459.67, -459.67, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtRsb), _
           f.Val(pvtGasSG), _
           f.Val(pvtOilSG), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal Rsb as Double, _
	    ByVal gasSG as Double, _
	    ByVal oilSG as Double, _
	    ByVal T as Double) as Double
	
	    oilSG = API(oilSG)
	    
	    Dim a1# = 1.42828*10^(-10)
	    Dim a2# = 2.844591797
	    Dim a3# = -6.74896*10^(-4)
	    Dim a4# = 1.225226436
	    Dim a5# = 0.033383304
	    Dim a6# = -0.272945957
	    Dim a7# = -0.084226069
	    Dim a8# = 1.869979257
	    Dim a9# = 1.221486524
	    Dim a10# = 1.370508349
	    Dim a11# = 0.011688308
	    
	    Dim A# = (a1 * T ^ a2 + a3 * oilSG ^ a4) / (a5 + 2 * Rsb ^ a6 / gasSG ^ a7) ^ 2
	    Return a8 * (Rsb ^ a9 / gasSG ^ a10 * 10 ^ A + a11)
	
	End Function

End Class
