Public Class PbubByGlaso1994

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "Glaso (1994)", "MPa")

		Input(pvtRsb, 16, 475, "std m3/m3")
		Input(pvtOilSG, 0.7878, 0.92)
		Input(pvtGasSG, 0.65, 1.276)
		Input(pvtT, 80.33, 280.13, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRsb), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rsb As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim Pb As Double
	    Pb = 4.087 * (Rsb / gasSG) ^ 0.816 * T ^ 0.172 / oilSG ^ 0.989
	
	    DoEval = 10 ^ ((-0.3946 + 1.74471 * Log10(Pb) - 0.30218 * (Log10(Pb)) ^ 2))
	
	End Function

End Class
