Public Class PbubByKartoatmodjo1994MediumOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "Kartoatmodjo (1994, medium oils)", "MPa")

		Input(pvtRsb, 0, 520, "std m3/m3")
		Input(pvtOilSG, 0.87, 0.92)
		Input(pvtT, 297, 333, "K")
		Input(pvtSepP, 0.07, 41.37, "MPa")
		Input(pvtSepT, 37.13, 294.53, "F")
		Input(pvtSepGasSG, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtSepGasSG), _
           f.Val(pvtRsb), _
           f.Val(pvtSepP), _
           f.Val(pvtSepT), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal sepGasSG As Double, _
	    ByVal Rsb As Double, _
	    ByVal sepP As Double, _
	    ByVal sepT As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	    
	    Dim gcorr As Double
	    gcorr = sepGasSG * (1 + 0.1595 * oilSG ^ 0.4078 * sepT ^ (-0.2466) * Log10(sepP / 0.7909))
	
	    Dim mult As Double
	    mult = 10 ^ (7.21531 * oilSG / (1.8 * T))
	
	    DoEval = 0.006895 * ((Rsb / 0.1801) / (0.09902 * gcorr ^ 0.2181 * mult)) ^ 0.9997
	
	End Function

End Class
