Public Class PbubByMcCain1991

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "McCain (1991)", "MPa")

		Input(pvtRsb, 0, 0, "std m3/m3")
		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtT, -459.67, 325.13, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRsb), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rsb As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim Cpb As Double
	    Cpb = (Rsb / (0.1801 * gasSG)) ^ 0.83 * 10 ^ (0.00091 * T - 0.0125 * oilSG)
	
	    DoEval = 0.125 * (Cpb - 1.4)
	
	End Function

End Class
