Public Class PbubByPetroskyAndFarshad1993

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "Petrosky and Farshad (1993)", "MPa")

		Input(pvtRsb, 39, 353, "std m3/m3")
		Input(pvtOilSG, 0.802, 0.957)
		Input(pvtGasSG, 0.5781, 0.8519)
		Input(pvtT, 114.53, 287.33, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRsb), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rsb As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim x As Double
	    x = 0.00004561 * T ^ 1.3911 - 0.0007916 * oilSG ^ 1.541
	
	    DoEval = 0.777 * (2.708 * Rsb ^ 0.5774 * 10 ^ x / gasSG ^ 0.8439 - 12.34)
	
	End Function

End Class
