Public Class PbubByStanding1981

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "Standing (1981)", "MPa")

		Input(pvtRsb, 3.6, 399, "std m3/m3")
		Input(pvtOilSG, 0, 1)
		Input(pvtGasSG, 0.59, 0.95)
		Input(pvtT, 311, 399, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRsb), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rsb As Double, _
	    ByVal T As Double) As Double
	
	    Dim yg# = 1.225 + 0.00164 * T - 1.769 / oilSG
	
	    DoEval = 0.5197 * (Rsb / gasSG) ^ 0.83 * 10 ^ yg
	   
	End Function

End Class
