Public Class PbubByStanding1994HeavyOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtPbub, "Standing (1994, heavy oils)", "MPa")

		Input(pvtRsb, 3.6, 256.6, "std m3/m3")
		Input(pvtOilSG, 0.929, 1)
		Input(pvtGasSG, 0.59, 0.95)
		Input(pvtT, 100.13, 258.53, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtRsb), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Rsb As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    DoEval = _
	        0.1084 * ((Rsb / (0.1801 * gasSG)) ^ 0.7885 * 10 ^ (0.002 * T - 0.0142 * oilSG))
	
	End Function

End Class
