Public Class RsbByDindorukChristman2001

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Dindoruk-Christman (2001)", "std scf/bbl")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtT, -459.67, -459.67, "F")
		Input(pvtPbub, 0, 0, "Psia")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtPbub), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG as Double, _
	    ByVal gasSG as Double, _
	    ByVal pbub as Double, _
	    ByVal T as Double) as Double
	
	    oilSG = API(oilSG)
	    
	    Dim a1# = 4.86996*10^(-6)
	    Dim a2# = 5.730982539
	    Dim a3# = 9.92510*10^(-3)
	    Dim a4# = 1.776179364
	    Dim a5# = 44.25002680
	    Dim a6# = 2.702889206
	    Dim a7# = 0.744335673
	    Dim a8# = 3.35975497
	    Dim a9# = 28.10133245
	    Dim a10# = 1.57905016
	    Dim a11# = 0.928131344
	    
	    Dim A# = (a1 * oilSG ^ a2 + a3 * T ^ a4) / (a5 + 2 * oilSG ^ a6 / pbub ^ a7) ^ 2
	    Return ((pbub / a8 + a9) * gasSG ^ a10 * 10 ^ A) ^ a11
	
	End Function

End Class
