Public Class RsbByGlaso1994

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Glaso (1994)", "std scf/bbl")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtT, -459.67, -459.67, "F")
		Input(pvtPbub, 0, 0, "Psia")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtT), _
           f.Val(pvtPbub))

	End Function

	Public Function DoEval( _
	    ByVal oilSG as Double, _
	    ByVal gasSG as Double, _
	    ByVal T as Double, _
	    ByVal pbub as Double) as Double
	
	    oilSG = API(oilSG)
	    
	    Dim X# = (-1.7447 + sqrt(3.044 + 1.20872 * (1.7669 - log10(pbub)))) / (-0.60436)
	    Return gasSG * (10 ^ X / (T ^ 0.172 / oilSG ^ 0.989)) ^ (1 / 0.816)
	
	End Function

End Class
