Public Class RsbByKartoatmodjo1994MediumOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Kartoatmodjo (1994, medium oils)", "std m3/m3")

		Input(pvtOilSG, 0.87, 0.92)
		Input(pvtGasSG, 0.4824, 1.668)
		Input(pvtT, 297, 433, "K")
		Input(pvtSepP, 0.07, 41.37, "MPa")
		Input(pvtSepT, 37.13, 294.53, "F")
		Input(pvtPbub, 0, 6033.3575054387, "Psia")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtSepP), _
           f.Val(pvtSepT), _
           f.Val(pvtPbub), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal sepP As Double, _
	    ByVal sepT As Double, _
	    ByVal Pb As Double, _
	    ByVal T As Double) As Double
		
	    oilSG = API(oilSG)
	
	    Dim gcorr# = gasSG * (1 + 0.1595 * _
	        oilSG ^ 0.4078 * sepT ^ (-0.2466) * Log10(sepP / 0.7909))
	
		Dim mult#
        mult = 10 ^ (7.4576 * oilSG / (1.8 * T))
	
	    DoEval = _
	        0.0182 * gcorr ^ 0.2556 * Pb ^ 0.9868 * mult
	
	End Function

End Class
