Public Class RsbByMoiseeva1972

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Moiseeva (1972)", "std m3/m3")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtPbub, 0, 0, "Bar")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtPbub))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Pb As Double) As Double
	
	    DoEval = 0.171 * Pb * gasSG / (1.409 * oilSG - 1) + 22.5 * oilSG - 20.37
	
	End Function

End Class
