Public Class RsbByPetroskyAndFarshad1993

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Petrosky and Farshad (1993)", "std m3/m3")

		Input(pvtOilSG, 0.802, 0.957)
		Input(pvtGasSG, 0.5781, 0.8519)
		Input(pvtT, 114.53, 287.33, "F")
		Input(pvtPbub, 10.9, 45, "MPa")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtPbub), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Pb As Double, _     
	    ByVal T As Double) As Double
	                     
	    oilSG = API(oilSG)
	
	    Dim x As Double
	    x = 0.0007916 * oilSG ^ 1.541 - 0.00004561 * T ^ 1.3911
	
	    DoEval = (0.369 * (Pb / 0.777 + 12.34) * gasSG ^ 0.8439 * 10 ^ x) ^ 1.73184
	
	End Function

End Class
