Public Class RsbByStanding1947

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Standing (1947)", "std m3/m3")

		Input(pvtOilSG, 0.804, 0.938)
		Input(pvtGasSG, 0.59, 0.95)
		Input(pvtT, 100.13, 258.53, "F")
		Input(pvtPbub, 0.896, 48.27, "MPa")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtPbub), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Pb As Double, _
	    ByVal T As Double) As Double
	
	    oilSG = API(oilSG)
	
	    Dim mult As Double
	    mult = 10 ^ (0.0169 * oilSG - 0.00156 * T)
	
	    DoEval = 0.1801 * gasSG * (Pb * mult / 0.0738) ^ 1.1128
	
	End Function

End Class
