Public Class RsbByTagintseva1983LightOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Tagintseva (1983, light oils)", "std m3/m3")

		Input(pvtOilSG, 0, 0)
		Input(pvtGasSG, 0, 0)
		Input(pvtPbub, 0, 0, "Bar")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtGasSG), _
           f.Val(pvtPbub))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal gasSG As Double, _
	    ByVal Pb As Double) As Double
	
	    DoEval = 25.63 + 2.94 * Pb - 21.93 * oilSG - 3.35 * Pb * oilSG - 10.125 * gasSG + 0.8 * Pb * gasSG
	
	End Function

End Class
