Public Class RsbByTagintseva1985LightOils

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtRsb, "Tagintseva (1985, light oils)", "std m3/m3")

		Input(pvtOilSG, 0.804, 0.938)
		Input(pvtT, 37.85, 125.85, "C")
		Input(pvtPbub, 8.96, 482.7, "Bar")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtPbub), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal Pb As Double, _
	    ByVal T As Double) As Double
	
	    Dim a0 As Double
	    a0 = 6.793 + 4.111 * Pb - 0.0093 * Pb ^ 2 + 0.0000238 * Pb ^ 3
	
	    Dim a1 As Double
	    a1 = -6.633 - 4.722 * Pb + 0.0125 * Pb ^ 2 - 0.000039 * Pb ^ 3
	
	    Dim a2 As Double
	    a2 = -1.607 + 0.708 * Pb - 0.00158 * Pb ^ 2 + 0.000012 * Pb ^ 3
	
	    Dim b0 As Double
	    b0 = 1.311411 - 77.460335 / Pb + 2968.1968 / (Pb ^ 2) - 21863.6055 / (Pb ^ 3)
	
	    Dim b1 As Double
	    b1 = 6.552134 - 979.601 / Pb + 34770.549 / (Pb ^ 2) - 252151.164 / (Pb ^ 3)
	
	    Dim b2 As Double
	    b2 = 20.563 - 2736.995 / Pb + 94196.913 / (Pb ^ 2) - 678383.656 / (Pb ^ 3)
	
	    Dim b3 As Double
	    b3 = -0.002697 - 0.1195 / Pb + 3.0274 / (Pb ^ 2) - 19.836 / (Pb ^ 3)
	
	    Dim oilSGLog As Double
	    oilSGLog = Log(oilSG)
	
	    Dim yg As Double
	    yg = b0 + b1 * oilSGLog + b2 * oilSGLog ^ 2 + b3 * T
	
	    DoEval = a0 + a1 * oilSG + a2 * yg
	
	End Function

End Class
