Public Class SatOilViscosityByBeggsRobinson

    Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "Beggs and Robinson (1994)")

        Input(pvtOilSG, 0.7467, 0.9593)
        Input(pvtRs, 3.6, 373)
        Input(pvtDeadVisc)

    End Sub

    Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

        DoEvaluate = DoEval( _
            f.Val(pvtOilSG), _
            f.Val(pvtRs), _
            f.Val(pvtDeadVisc))

    End Function

    Public Function DoEval( _
        ByVal oilSG As Double, _
        ByVal Rs As Double, _
        ByVal Uod As Double) As Double

        DoEval = (25.1921 * (Rs / 0.1801 + 100) ^ (-0.6487)) * Uod ^ (2.7516 * (Rs / 0.1801 + 150) ^ (-0.2135))

    End Function

End Class


