Public Class SatOilViscosityByKartoatmodjoE

    Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "Kartoatmodjo (1994, extra-heavy oils)")

        Input(pvtOilSG, 1, 2)
        Input(pvtRs, 0.18, 368)
        Input(pvtDeadVisc, 0.5062, 682)

    End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
			f.Val(pvtOilSG), _
			f.Val(pvtRs), _
			f.Val(pvtDeadVisc))

	End Function

    Public Function DoEval( _
        ByVal oilSG As Double, _
        ByVal Rs As Double, _
        ByVal Uod As Double) As Double
       
        Dim y# = 10 ^ (-0.0045 * Rs)
        Dim f# = (-0.0335 + 1.0785 * 10 ^ (-0.00469 * Rs)) * Uod ^ (0.5798 + 0.3432 * y)

        DoEval = 2.3945 + 0.8927 * f + 0.001567 * f ^ 2

    End Function

End Class


