Public Class SatOilViscosityByKartoatmodjoM

    Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "Kartoatmodjo (1994, medium oils)")

        Input(pvtOilSG, 0.87, 0.92)
        Input(pvtRs, 0.18, 368)
        Input(pvtDeadVisc, 0.5062, 682)

    End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
			f.Val(pvtOilSG), _
			f.Val(pvtRs), _
			f.Val(pvtDeadVisc))

	End Function

    Public Function DoEval( _
        ByVal oilSG As Double, _
        ByVal Rs As Double, _
        ByVal Uod As Double) As Double
      
        Dim y# = 10 ^ (-0.0045 * Rs)
		Dim f# = (0.2038 + 0.8591 * 10 ^ (-0.00469 * Rs)) * Uod ^ (0.3855 + 0.5664 * y)

        DoEval = 0.0132 + 0.9821 * f - 0.005215 * f ^ 2

    End Function

End Class


