Public Class SatOilViscosityByMcCain

    Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "McCain (1991)")

        Input(pvtRs) ', 0.18, 368)
        Input(pvtDeadVisc) ', 0.5062, 682)

    End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
		 f.Val(pvtRs), _
		 f.Val(pvtDeadVisc))

	End Function

    Public Function DoEval( _
        ByVal Rs As Double, _
        ByVal Uod As Double) As Double

        Dim a As Double
        Dim b As Double

        a = 10.715 * (Rs / 0.1801 + 100) ^ (-0.515)
        b = 5.44 * (Rs / 0.1801 + 150) ^ (-0.338)
        DoEval = a * Uod ^ b

    End Function

End Class


