Public Class SatOilViscosityByMoiseevaTD1972

    Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "Moiseeva (1972)")

        Input(pvtOilSG)
        Input(pvtRs)
        Input(pvtDeadVisc)

    End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
		 f.Val(pvtOilSG), _
		 f.Val(pvtRs), _
		 f.Val(pvtDeadVisc))

	End Function

    Public Function DoEval( _
        ByVal oilSG As Double, _
        ByVal Rs As Double, _
        ByVal Uod As Double) As Double

        DoEval = (0.46 - 0.0015 * Rs + 0.6453 * Exp(-0.0792 * Rs)) * Uod - 0.002 * Rs - 0.6976 * Exp(-0.0889 * Rs) + 0.52

    End Function

End Class


