Public Class SatOilViscosityByStanding

    Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "Standing (1947)")

        Input(pvtRs, 3.6, 256.6)
        Input(pvtDeadVisc)

    End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
			f.Val(pvtRs), _
			f.Val(pvtDeadVisc))

	End Function

    Public Function DoEval( _
        ByVal Rs As Double, _
        ByVal Uod As Double) As Double

        Dim a As Double
        Dim b As Double

        a = 5.6148 * Rs * (0.000001235 * Rs - 0.00074)
        b = 0.68 / (10 ^ (0.000484 * Rs)) + 0.25 / (10 ^ (0.006176 * Rs)) + 0.062 / (10 ^ (0.021 * Rs))
        DoEval = 10 ^ a * Uod ^ b

    End Function

End Class


