Public Class SatOilViscosityByTagencevaGP1983
    
	Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "Tagintseva (1983, ligth oils)")

        Input(pvtRs)
        Input(pvtRsb)
        Input(pvtDeadVisc)

    End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
		 f.Val(pvtRs), _
		 f.Val(pvtDeadVisc), _
		 f.Val(pvtRsb))

	End Function

    Public Function DoEval( _
        ByVal Rs As Double, _
        ByVal Uod As Double, _
        ByVal Rsb As Double) As Double

        If Rsb > 80 Then
            DoEval = 0.3996 - 0.001757 * Rs + Uod * (0.3592 - 0.0004857 * Rs)
        Else
            Dim a0 As Double
            Dim a1 As Double
            Dim a2 As Double
            Dim a3 As Double
            Dim logVisc As Double

            logVisc = Log(Uod)

            a0 = (0.578 * Exp(3.006 * logVisc ^ 2 - 0.877 * logVisc ^ 3)) / Uod ^ 2.667
            a1 = 1.203 + 126.5 * logVisc - 102.541 * logVisc ^ 2 + 51.022 * logVisc ^ 3
            a2 = 96.576 - 2274.592 * logVisc + 2076.797 * logVisc ^ 2 - 969.664 * logVisc ^ 3
            a3 = -806.283 + 12313.657 * logVisc - 11779.12 * logVisc ^ 2 + 5398.074 * logVisc ^ 3

            DoEval = a0 + a1 / Rs + a2 / Rs ^ 2 + a3 / Rs ^ 3
        End If

    End Function

End Class


