Public Class SatOilViscosityByTagencevaGP1985
    
	Inherits OilCorrelation

    Public Sub New()
        MyBase.New(pvtSatVisc, "Tagintseva (1985, ligth oils)")

        Input(pvtDeadVisc)
        Input(pvtOilSG)
        Input(pvtP, 1, 12, "Bar")
    End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
			f.Val(pvtOilSG), _
			f.Val(pvtDeadVisc), _
			f.Val(pvtP))

	End Function

    Public Function DoEval( _
        ByVal oilSG As Double, _
        ByVal Uod As Double, _
        ByVal P As Double) As Double

        Dim lnP# = Log(P)
        Dim b0# = 21.83879 - 20.582796 * lnP + 5.694244 * lnP ^ 2 - 0.504515 * lnP ^ 3
        Dim b1# = 0.936561 + 0.000309 * P - 0.0000535 * P ^ 2 + 0.0000003 * P ^ 3
        Dim b2# = -15.161861 + 14.920657 * lnP - 4.129528 * lnP ^ 2 + 0.364171 * lnP ^ 3

        DoEval = b0 + b1 * Uod + b2 * oilSG

    End Function

End Class


