Public Class SepGORByMcCain1991

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtSepGOR, "McCain (1991)", "std m3/m3")

		Input(pvtOilSG, 0.6, 0.9)
		Input(pvtSepP, 0.2, 2.2, "MPa")
		Input(pvtSepT, 60.53, 148.73, "F")
		Input(pvtSepGasSG, 0.59, 0.95)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtSepGasSG), _
           f.Val(pvtSepP), _
           f.Val(pvtSepT))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal sepGasSG As Double, _
	    ByVal sepP As Double, _
	    ByVal sepT As Double) As Double
	
	    Const A1 As Double = 0.3818
	    Const A2 As Double = -5.506
	    Const A3 As Double = 2.902
	    Const A4 As Double = 1.327
	    Const A5 As Double = -0.7355
	
	    Dim a As Double
	    a = A1 + A2 * Log10(oilSG) + A3 * Log10(sepGasSG) + A4 * Log10(145.033 * sepP) + A5 * Log10(sepT)
	
	    DoEval = 0.1801 * 10 ^ a
	
	End Function

End Class
