Public Class UnSatViscByBeal1946

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtUnSatVisc, "Beal (1946)", "mPa*s")

		Input(pvtP, 0, 68, "MPa")
		Input(pvtPbub, 0, 0, "MPa")
		Input(pvtOilViscBub, 0, 0, "mPa*s")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtPbub), _
           f.Val(pvtOilViscBub), _
           f.Val(pvtP))

	End Function

	Public Function DoEval( _
	    ByVal Pb As Double, _
	    ByVal Uob As Double, _
	    ByVal P As Double) As Double
	
	    Dim delta As Double
	    If Uob < 5 Then
	        delta = 0.0114 * Uob
	    ElseIf Uob < 10 Then
	        delta = 0.057 + 0.023 * (Uob - 5)
	    ElseIf Uob < 25 Then
	        delta = 0.171 + 0.031 * (Uob - 10)
	    ElseIf Uob < 45 Then
	        delta = 0.643 + 0.045 * (Uob - 25)
	    ElseIf Uob < 75 Then
	        delta = 1.539 + 0.058 * (Uob - 45)
	    ElseIf Uob < 85 Then
	        delta = 3.286 + 0.1 * (Uob - 75)
	    End If
	
	    DoEval = Uob + delta * (P - Pb)
	
	End Function

End Class
