Public Class UnSatViscByKartoatmodjo1994

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtUnSatVisc, "Kartoatmodjo (1994)", "mPa*s")

		Input(pvtP, 0.1, 49.44, "MPa")
		Input(pvtPbub, 0.41, 64, "MPa")
		Input(pvtOilViscBub, 0.096, 586, "mPa*s")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtPbub), _
           f.Val(pvtOilViscBub), _
           f.Val(pvtP))

	End Function

	Public Function DoEval( _
	    ByVal Pb As Double, _
	    ByVal UoSat As Double, _
	    ByVal P As Double) As Double
	
	    DoEval = 0.9886 * UoSat + 0.40073 * (P - Pb) * ((-0.01153) * UoSat ^ 1.7933 + 0.0316 * UoSat ^ 1.5939)
	
	End Function

End Class
