Public Class UnSatViscByLabedi1994

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtUnSatVisc, "Labedi (1994)", "mPa*s")

		Input(pvtOilSG, 0.788, 0.864)
		Input(pvtP, 0, 50, "MPa")
		Input(pvtPbub, 0.4, 43.8, "MPa")
		Input(pvtDeadVisc, 0.66, 4.79, "mPa*s")
		Input(pvtOilViscBub, 0.115, 3.72, "mPa*s")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtOilSG), _
           f.Val(pvtPbub), _
           f.Val(pvtDeadVisc), _
           f.Val(pvtOilViscBub), _
           f.Val(pvtP))

	End Function

	Public Function DoEval( _
	    ByVal oilSG As Double, _
	    ByVal Pb As Double, _
	    ByVal Uod As Double, _
	    ByVal UoSat As Double, _
	    ByVal P As Double) As Double
	
	    Dim Prsv As Double
	    If 0.87 < oilSG Or oilSG < 0.92 Then 'medium oils
	
	        oilSG = API(oilSG)
	        Prsv = P / 0.006895
	
	        DoEval = UoSat - ((1 - P / Pb) * 10 ^ (-3.8055) * Uod ^ 1.4131 * Prsv ^ 0.6957 / 10 ^ ((-0.00288) * oilSG))
	
	    ElseIf 1 < oilSG Then  'extra heavy oils
	
	        oilSG = API(oilSG)
	        Prsv = P / 0.006895
	
	        DoEval = UoSat - ((1 - P / Pb) * 10 ^ (-2.19) * Uod ^ 1.055 * Prsv ^ 0.3132 / 10 ^ (0.0099 * oilSG))
	    End If
	
	End Function

End Class
