Public Class UnSatViscByMcCain1991

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtUnSatVisc, "McCain (1991)", "mPa*s")

		Input(pvtP, 0, 65.6, "MPa")
		Input(pvtPbub, 0, 0, "MPa")
		Input(pvtOilViscBub, 0, 0, "mPa*s")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtPbub), _
           f.Val(pvtOilViscBub), _
           f.Val(pvtP))

	End Function

	Public Function DoEval( _
	    ByVal Pb As Double, _
	    ByVal Uob As Double, _
	    ByVal P As Double) As Double
	
	    Dim f As Double
	    Dim C1 As Double
	    Dim C2 As Double
	    Dim C3 As Double
	    Dim C4 As Double
	
	    C1 = 2.6
	    C2 = 1.187
	    C3 = -11.513
	    C4 = -0.0000898
	
	    f = C1 * (P / 0.006895) ^ C2 * Exp(C3 + C4 * P / 0.006895)
	    DoEval = Uob * (P / Pb) ^ f
	
	End Function

End Class
