Public Class UnSatViscByStanding1947

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtUnSatVisc, "Standing (1947)", "mPa*s")

		Input(pvtP, 0, 0, "MPa")
		Input(pvtPbub, 0.896, 48.27, "MPa")
		Input(pvtOilViscBub, 0, 0, "mPa*s")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtPbub), _
           f.Val(pvtOilViscBub), _
           f.Val(pvtP))

	End Function

	Public Function DoEval( _
	    ByVal Pb As Double, _
	    ByVal Uob As Double, _
	    ByVal P As Double) As Double
	
	    DoEval = Uob + 0.14504 * (P - Pb) * (0.024 * Uob ^ 1.6 + 0.038 * Uob ^ 0.56)
	
	End Function

End Class
