Public Class UnSatViscByVasquezAndBeggs1994

	Inherits OilCorrelation

	Public Sub New()
		MyBase.New(pvtUnSatVisc, "Vasquez and Beggs (1994)", "mPa*s")

		Input(pvtP, 0.9, 65.5, "MPa")
		Input(pvtPbub, 0, 0, "MPa")
		Input(pvtOilViscBub, 0, 0, "mPa*s")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtPbub), _
           f.Val(pvtOilViscBub), _
           f.Val(pvtP))

	End Function

	Public Function DoEval( _
	    ByVal Pb As Double, _
	    ByVal Uob As Double, _
	    ByVal P As Double) As Double
	
	    Const C1 As Double = 956.44
	    Const C2 As Double = 1.187
	    Const C3 As Double = -11.513
	    Const C4 As Double = -0.01302
	
	    Dim m As Double
	    m = C1 * P ^ C2 * Exp(C3 + C4 * P)
	
	    DoEval = Uob * (P / Pb) ^ m
	
	End Function

End Class
