Public Class FrictionFByBarr1983

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Barr (1983)", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	    
	    Dim eD# = rough / diam
	    Dim eD37# = eD / 3.7
	    
	    Dim f05$ = -2 * Log(eD37 + 4.518 * Log(Re / 7) / Re / (1 + Re ^ 0.52 * (eD) ^ 0.7 / 29))
	    return 1 / f05 ^ 2
	
	End Function
	

End Class
