Public Class FrictionFByChen1979

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Chen (1979)", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	
	    Dim eD# = rough / diam
	    Dim eD37# = eD / 3.7065
	    
	    Dim f05# = -2 * Log(eD37 - 5.0452 / Re * Log((eD) ^ 1.1098 / 2.8257 + 5.8506 / Re ^ 0.8981))
	    
	    return 1 / f05 ^ 2
	
	End Function
	

End Class
