Public Class FrictionFByChurchill1977

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Churchill (1977)", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	
	    Dim eD37# = rough / diam / 3.7
	    
	    Dim A# = (-2.457 * Log(eD37 + (7 / Re) ^ 0.9)) ^ 16
	    
	    Dim B# = (37530 / Re) ^ 16
	    
	    return 2 * ((8 / Re) ^ 12 + (A + B) ^ (-1.5)) ^ (1 / 12)
	
	End Function
	

End Class
