Public Class FrictionFByClamond2009

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Clamond (2009)", "")

		Input(pvtDiam, 0, 0, "mm")
		Input(pvtRough, 0, 0, "mm")
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	    
	    Dim log_10# = log10(10)
	    Dim eD# = rough / diam
	    Dim x1# = eD * Re * log_10 / 18.574
	    Dim x2# = log(Re * log_10 / 5.02)
	
	    const itmax# = 2
	
	    Dim z# = x2 - 0.5
	    Dim e#
	    
	    Dim j as integer
	    for j = 1 to itmax
	        e = (z + log(x1 + z) - x2) / (1 + x1 + z)
	        z -= (1 + x1 + z + .5 * e) * e * (x1 + z) / (1 + x1 + z + e * (1 + e / 3))
	    next
	    return (.5 * log_10 / z) ^ 2
	
	End Function

End Class
