Public Class FrictionFByGhanbari2011

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Ghanbari (2011)", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	
	    Dim eD# = rough / diam
	    return (-1.52 * Log((eD / 7.21) ^ 1.042 + (2.731 / Re) ^ 0.9152)) ^ (-2.169)
	    
	End Function
	

End Class
