Public Class FrictionFByHaaland1983

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Haaland (1983)", "")

		Input(pvtDiam, 0, 0, "mm")
		Input(pvtRough, 0, 0, "mm")
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	
	    Dim eD37# = rough / diam / 3.7
	    
	    Dim f05# = -1.8 * Log(eD37 ^ 1.11 + 6.9 / Re)
	    return 1 / f05 ^ 2
	
	End Function

End Class
