Public Class FrictionFByJain

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Jain", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	    
	    Dim eD# = rough / diam
	    Dim f05# = 1.14 - 2 * Log(eD + 21.25 / Re ^ 0.9)
	
	    return 1 / f05 ^ 2
	End Function
	

End Class
