Public Class FrictionFByNikuradze

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Nikuradze", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double) as Double
	
	    Dim eD# = rough / diam
	    Dim f05# = 1.74 - 2 * Log(2 * eD)
	    Return 1 / f05 ^ 2
	
	End Function
	

End Class
