Public Class FrictionFByPapaevan2010

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Papaevan (2010)", "")

		Input(pvtDiam, 0, 0, "mm")
		Input(pvtRough, 0, 0, "mm")
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	
	    Dim a1# = .2479
	    Dim a2# = .0000947
	    Dim a3# = 3.615
	    Dim a4# = 7.366
	    Dim a5# = .9142
	    
	    Dim eD# = rough / diam
	    Dim denom# = log(eD / a3 + a4 / Re ^ a5)
	    return (a1 - a2 * pow(7 - log(Re), 4)) / denom ^ 2
	    
	End Function

End Class
