Public Class FrictionFByRomeo2002

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Romeo (2002)", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	
	    Dim eD# = rough / diam
	    Dim A# = Log(eD / 3.827 - 4.567 / Re * Log((eD / 7.7918) ^ 0.9924 + (5.3326 / (208.815 + Re)) ^ 0.9345))
	    
	    Dim f05# = -2 * Log(eD / 3.7065 - 5.0272 / Re * A)
	    return 1 / f05 ^ 2
	
	End Function
	

End Class
