Public Class FrictionFByZigrandSilvester1982

	Inherits PipeCorrelation

	Public Sub New()
		MyBase.New(pvtFrictionF, "Zigrand-Silvester (1982)", "")

		Input(pvtDiam, 0, 0)
		Input(pvtRough, 0, 0)
		Input(pvtRe, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDiam), _
           f.Val(pvtRough), _
           f.Val(pvtRe))

	End Function

	Public Function DoEval( _
	    ByVal diam as Double, _
	    ByVal rough as Double, _
	    ByVal Re as Double) as Double
	    
	    Dim eD37# = rough / diam / 3.7    
	    Dim f05# = -2 * Log(2 * eD37 - 5.02 / Re * Log(eD37 + 13 / Re))    
	    return 1 / f05 ^ 2
	End Function
	

End Class
