Public Class BwByGould

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtBw, "Gould", "m3/m3")

		Input(pvtP, 0, 0, "Psia")
		Input(pvtT, -459.67, -459.67, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal P as Double, _
	    ByVal T as Double) as Double
	
	    Return 1 + 1.2 * 10 ^ (-4) * (T - 60) + 10 ^ (-6) * (T - 60) ^ 2 - 3.33 * 10 ^ (-6) * P
	
	End Function
	

End Class
