Public Class BwByMcCain1991

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtBw, "McCain (1991)", "m3/m3")

		Input(pvtP, 14.5032632342, 5003.6258158086, "Psia")
		Input(pvtT, 31.73, 260.33, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    Dim dV_wt# = -1.0001 * 10 ^ (-2) + 1.33391 * 10 ^ (-4) * T + 5.50654 * 10 ^ (-7) * T ^ 2
	    Dim dV_wp# = -1.95301 * 10 ^ (-9) * P * T - 1.72834 * 10 ^ (-13) * P ^ 2 * T - 3.58922 * 10 ^ (-7) * P - 2.25341 * 10 ^ (-10) * P ^ 2
	
	    DoEval = (1 + dV_wp) * (1 + dV_wt)
	
	End Function

End Class
