Public Class BwByShylov1985

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtBw, "Shylov (1985)", "m3/m3")

		Input(pvtWaterDensSC, 0, 0, "kg/m3")
		Input(pvtRw, 0, 0, "std m3/m3")
		Input(pvtWaterDensRC, 0, 0, "kg/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtWaterDensSC), _
           f.Val(pvtWaterDensRC), _
           f.Val(pvtRw))

	End Function

	Public Function DoEval( _
	    ByVal rhoSC As Double, _
	    ByVal rhoRC As Double, _
	    ByVal Rw As Double) As Double
	
	    DoEval = rhoSC * (1 + 0.0008 * Rw) / rhoRC
	    
	End Function

End Class
