Public Class RwByGimatudinov

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtRw, "Gimatudinov", "std m3/m3")

		Input(pvtP, 0, 0, "MPa")
		Input(pvtWaterPbub, 0, 0, "MPa")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtWaterPbub))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal Pb As Double) As Double
	
	    P = min(P, Pb)
	    
	    Dim alpha# = 0.15
	    DoEval = alpha * P
	    
	End Function

End Class
