Public Class RwByMcCain1991

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtRw, "McCain (1991)", "std scf/bbl")

		Input(pvtP, 1013.7781000725, 10007.2516316171, "Psia")
		Input(pvtT, 69.53, 339.53, "F")
		Input(pvtWaterPbub, 0, 0, "Psia")
		Input(pvtSaltMassPart, 0, 30)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtWaterPbub), _
           f.Val(pvtT), _
           f.Val(pvtSaltMassPart))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal T As Double, _
	    ByVal s As Double) As Double
	
	    P = min(P, Pb)
	
	    Dim A# = 8.15839 - 6.12265 * 10 ^ (-2) * T + 1.91663 * 10 ^ (-4) * T ^ 2 - 2.1654 * 10 ^ (-7) * T ^ 3
	    Dim B# = 1.01021 * 10 ^ (-2) - 7.44241 * 10 ^ (-5) * T + 3.05553 * 10 ^ (-7) * T ^ 2 - 2.94883 * 10 ^ (-10) * T ^ 3
	    Dim C# = - 10 ^ (-7) * (9.02505 - 0.130237 * T + 8.53425 * 10 ^ (-4) * T ^ 2 - 2.34122 * 10 ^ (-6) * T ^ 3 + 2.37049 * 10 ^ (-9) * T ^ 4)
	
	    DoEval = (A + B * P + C * P ^ 2) * Exp(-0.0840655 * s * T ^ (-0.285854))
	    
	End Function

End Class
