Public Class RwByShylov

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtRw, "Shylov", "std m3/m3")

		Input(pvtP, 5, 100, "MPa")
		Input(pvtT, 0.1, 119.85, "C")
		Input(pvtWaterPbub, 0, 0, "MPa")
		Input(pvtSaltMassPart, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtWaterPbub), _
           f.Val(pvtT), _
           f.Val(pvtSaltMassPart))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal Pb As Double, _
	    ByVal T As Double, _
	    ByVal salinity As Double) As Double
	
	    P = min(P, Pb)
	    
	    Dim a# = 0.3705 * Exp(0.114 * Log(T))
	    Dim b# = 0.1477 - 0.533 * Log(T)
	
	    DoEval = (1 - (0.139 - 0.22 * Log(T)) * salinity) * Exp(a * (Log(P) + 2.3214) + b)
	
	End Function

End Class
