Public Class WaterCoByBrillBeggs1978

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterCo, "Brill-Beggs (1978)", "Psia-1")

		Input(pvtP, 0, 0, "Psia")
		Input(pvtT, -459.67, -459.67, "F")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal P as Double, _
	    ByVal T as Double) as Double
	
	    Dim C1# = 3.8546 - 0.000134 * P
	    Dim C2# = -0.01052 + 4.77 * 10 ^ (-7) * P
	    Dim C3# = 3.9267 * 10 ^ (-5) - 8.8 * 10 ^ (-10) * P
	
	    Return (C1 + C2 * T + C3 * T ^ 2) * 10 ^ (-6)
	
	End Function
	

End Class
