Public Class WaterCoByShylovAtPPb

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterCo, "Shylov (at P < Pb)", "MPa-1")

		Input(pvtDeadWaterCo, 0, 0, "MPa-1")
		Input(pvtRw, 0, 0, "std m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtDeadWaterCo), _
           f.Val(pvtRw))

	End Function

	Public Function DoEval( _
	    ByVal deadWaterCo As Double, _
	    ByVal Rw As Double) As Double
	
	    DoEval = deadWaterCo * (1 + 0.014 * Rw)
	    
	End Function

End Class
