Public Class WaterDensRCByGimatudinov

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterDensRC, "Gimatudinov", "kg/m3")

		Input(pvtT, 0, 0, "K")
		Input(pvtWaterDensSC, 0, 0, "kg/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtT), _
           f.Val(pvtWaterDensSC))

	End Function

	Public Function DoEval( _
	    ByVal T As Double, _
	    ByVal rhoSC As Double) As Double
	
	    DoEval = rhoSC / (1 + 0.0001 * (T - 273) * (0.269 * (T - 273) ^ 0.637 - 0.8))
	    
	End Function

End Class
