Public Class WaterDensRCByMcCain1991

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterDensRC, "McCain (1991)", "lb/ft3")

		Input(pvtSaltMassPart, 0, 0)
		Input(pvtBw, 0, 0, "m3/m3")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtSaltMassPart), _
           f.Val(pvtBw))

	End Function

	Public Function DoEval( _
	    ByVal salinity As Double, _
	    ByVal Bw As Double) As Double
	
	    Dim rhoSC As Double
	    rhoSC = 62.368 + 0.438603 * salinity + 1.60074 * 10 ^ (-3) * salinity ^ 2
	    
	    DoEval = rhoSC / Bw
	    
	End Function

End Class
