Public Class WaterDensRCByShylov1985

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterDensRC, "Shylov (1985)", "kg/m3")

		Input(pvtP, 0.1, 20, "MPa")
		Input(pvtT, -10.15, 119.85, "C")
		Input(pvtWaterDensSC, 0, 0, "kg/m3")
		Input(pvtRw, 0, 0, "std m3/m3")
		Input(pvtWaterCo, 0, 0, "MPa-1")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtWaterDensSC), _
           f.Val(pvtRw), _
           f.Val(pvtWaterCo), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal rhoSC As Double, _
	    ByVal Rw As Double, _
	    ByVal Co As Double, _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    Dim denom As Double
	    denom = (1 - Co * P) * (1 + (0.5 * T + 10) * (T - 20 * 10 ^ (-5)))
	
	    DoEval = (rhoSC - Rw) / denom
	
	End Function

End Class
