Public Class WaterGasTensByRN

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterGasTens, "RN", "N/m")

		Input(pvtP, 0, 0, "MPa")
		Input(pvtT, 0, 0, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    DoEval = 0.001 * (75 - 6.296 * P ^ 0.349 - (1.8 * T - 534) * (22 - 6.296 * P ^ 0.349 + 2.5256 * P ^ 0.637) / 206)
	    
	End Function

End Class
