Public Class WaterThermConductByGimatudinov

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterThermConduct, "Gimatudinov", "W/(m*K)")

		Input(pvtT, 273, 398, "K")
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal T As Double) As Double
	
	    DoEval = 0.686 - 0.000001 * (398 - T) ^ 2.45
	    
	End Function

End Class
