Public Class WaterViscByLyapkov

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterVisc, "Lyapkov", "mPa*s")

		Input(pvtT, 311, 478, "K")
		Input(pvtSaltMassPart, 0, 26)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtSaltMassPart), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal s As Double, _
	    ByVal T As Double) As Double
	
	    Dim nom As Double
	    nom = 1.4 + 6.46 * 10 ^ (-3) * (0.444 * s - 1)
	
	    Dim den As Double
	    den = 10 ^ (0.0065 * (T - 273))
	
	    DoEval = nom / den
	
	End Function

End Class
