Public Class WaterViscByMcCain1991

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterVisc, "McCain (1991)", "mPa*s")

		Input(pvtP, 0, 0, "Psia")
		Input(pvtT, 100.13, 400.73, "F")
		Input(pvtSaltMassPart, 0, 26)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtSaltMassPart), _
           f.Val(pvtP), _
           f.Val(pvtT))

	End Function

	Public Function DoEval( _
	    ByVal s As Double, _
	    ByVal P As Double, _
	    ByVal T As Double) As Double
	
	    Dim a As Double
	    a = 109.574 - 8.40564 * s + 0.313314 * s ^ 2 + 0.00872213 * s ^ 3
	
	    Dim b As Double
	    b = 1.12166 - 0.0263951 * s + 0.000679461 * s ^ 2 + 0.0000574119 * s ^ 3 - 0.00000155586 * s ^ 4
	
	    Dim mu_w1 As Double
	    mu_w1 = a * T ^ (-b)
	
	    DoEval = mu_w1 * (0.9994 + 4.0295 * 10 ^ (-5) * P + 3.1062 * 10 ^ (-9) * P ^ 2)
	                    
	End Function

End Class
