Public Class WaterViscByMeehan1980

	Inherits WaterCorrelation

	Public Sub New()
		MyBase.New(pvtWaterVisc, "Meehan (1980)", "cPoise")

		Input(pvtP, 0, 0, "Psia")
		Input(pvtT, -459.67, -459.67, "F")
		Input(pvtSaltMassPart, 0, 0)
	End Sub

	Protected Overrides Function DoEvaluate(ByRef f As Fluids) As Double

		DoEvaluate = DoEval( _
           f.Val(pvtT), _
           f.Val(pvtP), _
           f.Val(pvtSaltMassPart))

	End Function

	Public Function DoEval( _
	    ByVal T as Double, _
	    ByVal P as Double, _
	    ByVal WS as Double) as Double
	
	    Dim D# = 1.12166 - 0.0263951 * WS + 6.79461*10^(-4) * WS ^ 2 _
	        + 5.47119*10^(-5) * WS ^ 3 - 1.55586*10^(-6) * WS ^ 4
	    
	    Dim UwT# = (109.574 - 8.40564 * WS + 0.313314 * WS ^ 2 _
	        + 8.72213*10^(-3) * WS ^ 3) * T ^ (-D)
	
	    Return UwT * (0.9994 + 4.0295*10^(-5)*P + 3.1062*10^(-9)*P^2)
	
	End Function

End Class
